<template>
<div class="mt-3">
  <div class="d-flex justify-content-between">
    <h1 class="h2">Clients</h1>
    <router-link 
      :to="{ name: 'client_create' }"
      role="button"
      class="btn btn-primary py-2 px-4 rounded text-lg">
      Add New Client
    </router-link>
  </div>

  <!-- keywords search -->
  <div class="mb-3">
    <input v-model="keywords" placeholder="Search by company name"
      class="border-2 rounded w-1/4 py-2 px-4">
    <button @click="handleKeywordsChange" class="py-2 px-4 rounded text-lg ml-3">Search</button>
    <button @click="handleClearFilters" class="py-2 px-4 rounded text-lg ml-3">Clear</button>
  </div>

  <table v-if="! isLoading" class="table table-striped">
    <thead>
      <tr>
        <th v-for="(field, index) in fieldKeys" :key="index">
          {{field.toUpperCase().replace('_', ' ')}}
        </th>
        <th class="text-center">Actions</th>
      </tr>
    </thead>
    <tbody v-if="clientsList.length">
      <client v-for="client in clientsList" :key="client.id" :data="client" :fields="fieldKeys" />
    </tbody>
  </table>
  <loader v-else />

  <pagination 
    :total-pages="meta.totalPages" 
    :total="meta.total" 
    :per-page="meta.perPage" 
    :current-page="meta.currentPage"
    :has-more-pages="hasMorePages" 
    @pagechanged="pageChangeHandler" 
    class="text-2xl my-5 fs-5" />
</div>
</template>

<script>
import { mapState } from 'vuex';
import Client from '../components/Client';
import Loader from '../components/Loader';
import Pagination from '../components/Pagination';

export default {
  name: 'ClientsList',
  components: {
    Client, Pagination, Loader
  },
  data: function () {
    return {
      hasMorePages: true,
      queryString: window.location.search,
      keywords: '',
      fieldKeys: [
        'company_name',
        'address',
        'phone',
      ],
      clientsList: []
    }
  },
  computed: {
    ...mapState('clients', [
      'clients',
      'meta',
    ]),
    ...mapState('general', [
      'isLoading'
    ])
  },
  watch: {
    // need to watch clients data change for update and rerender the list
    '$store.state.clients.clients': function() {
      this.clientsList = this.clients
    }
  },
  mounted() {
    let searchParams = new URLSearchParams(this.queryString)
    if (searchParams.has('keywords')) {
      this.keywords = searchParams.get('keywords')
    }

    this.$store.dispatch('clients/getAllClients', this.queryString)
      .then(() => {
        this.clientsList = this.clients
      });
  },
  methods: {
    pageChangeHandler(pageNum) {
      this.currentPage = pageNum;
      let searchParams = new URLSearchParams(this.queryString);
      searchParams.set('page', pageNum)
      this.queryString = '?' + searchParams.toString();

      this.$store.dispatch('clients/getAllClients', this.queryString)
        .then(() => {
          window.history.pushState({}, '', window.location.href.split('?')[0] + this.queryString);
        })
    },
    handleKeywordsChange() {
      let searchParams = new URLSearchParams(this.queryString);
      if (searchParams.has('page')) {
        searchParams.delete('page')
      }
      searchParams.set('keywords', this.keywords);
      this.queryString = '?' + searchParams.toString();

      this.$store.dispatch('clients/getAllClients', this.queryString)
        .then(() => {
          window.history.pushState({}, '', window.location.href.split('?')[0] + this.queryString);
        })
    },
    handleClearFilters() {
      this.queryString = ''
      this.keywords = ''
      this.$store.dispatch('clients/getAllClients', this.queryString)
        .then(() => {
          window.history.pushState({}, '', window.location.href.split('?')[0])
        })
    }
  }
}
</script>